module Mutest
  module AST
    module Regexp
      class Transformer
        # Transformer for root nodes
        class Root < self
          register :regexp_root_expression

          ExpressionToAST = Class.new(Recursive::ExpressionToAST)

          # Mapper from `Parser::AST::Node` to `Regexp::Expression`
          class ASTToExpression < Transformer::ASTToExpression
            private

            # Transform node into root expression
            #
            # @return [Regexp::Expression::Root]
            def transform
              ::Regexp::Expression::Root.new.tap do |root|
                root.expressions = subexpressions
              end
            end
          end
        end
      end
    end
  end
end
